//+------------------------------------------------------------------+
//|                                                  AR3EURUSDH1a.mq4 |
//|                                                          PROFJIM |
//|                                                                  |
//+------------------------------------------------------------------+
#property copyright "PROFJIM"
#property link      ""
//buffers: 0.hpmid, 1.ahead, 2.vel, 3.acl, 4.aclhp
#property indicator_chart_window
#property indicator_buffers 7
#property indicator_color1 Orange
#property indicator_color2 Black
#property indicator_color3 Red
#property indicator_color4 Blue
#property indicator_color5 Green
#property indicator_color6 Yellow
#property indicator_color7 Green
//Global constants
#define pi 3.141592653589793238462643383279502884197169399375105820974944592

//Input parameters
extern int nobs    =300; //Number of bars to smooth
//Indicator buffers
double hpfmid[];
double ahead[];
double vel[];
double acl[];
double aclhp[];
double err[];
double midslda[];
//Global Variables
double R1[],R2[],R3[],V1[],V2[],V3[],A1[],A2[],A3[],M1[],M2[],M3[];
int COF1innm, COF2innm, COF3innm, ahdbars=2;
int lambda =1;    //Equivalent to SMA period      
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
//---- indicators
   IndicatorBuffers(7);
   SetIndexBuffer(0,hpfmid);
   SetIndexStyle(0,DRAW_LINE,STYLE_DASH,3,Orange);
   SetIndexLabel(0,"hpfmid");
   SetIndexBuffer(1,ahead);
   SetIndexStyle(1,DRAW_LINE,STYLE_SOLID,3,Black);
   SetIndexShift(1,ahdbars);
   SetIndexLabel(1,"ahead");
   SetIndexBuffer(2,vel);
   SetIndexStyle(2,DRAW_NONE,STYLE_SOLID,3,Red);
   SetIndexLabel(2,"vel");
   SetIndexBuffer(3,acl);
   SetIndexStyle(3,DRAW_NONE,STYLE_SOLID,3,Blue);
   SetIndexLabel(3,"acl");
   SetIndexBuffer(4,aclhp);
   SetIndexStyle(4,DRAW_NONE,STYLE_SOLID,3,Green);
   SetIndexLabel(4,"aclhp");
   SetIndexBuffer(5,err);
   SetIndexStyle(5,DRAW_NONE,STYLE_SOLID,3,Yellow);
   SetIndexLabel(5,"err");
   SetIndexBuffer(6,midslda);
   SetIndexStyle(6,DRAW_LINE,STYLE_SOLID,3,Green);
   SetIndexLabel(6,"midslda");
   SetIndexShift(6,ahdbars);
//----Get the files
double COF1[], COF2[], COF3[];
   int COF1in, COF1inbts, COF2in, COF2inbts, COF3in, COF3inbts;
   string COF1fl, COF2fl, COF3fl;
   string curwin=StringConcatenate(Symbol(),Period());
   COF1fl=StringConcatenate(curwin,"COF1");
   COF1in=FileOpen(COF1fl, FILE_BIN|FILE_READ);
   if(COF1in>0)
      {
      COF1inbts=FileSize(COF1in);
      COF1innm=COF1inbts/8;
      FileReadArray(COF1in, COF1, 0, COF1innm);
      FileClose(COF1in);
      Print("File ",COF1fl," loaded");
      ArrayResize(R1,COF1innm/4);
      ArrayResize(V1,COF1innm/4);
      ArrayResize(A1,COF1innm/4);
      ArrayResize(M1,COF1innm/4);
      for(int cof1i=0;cof1i<=COF1innm/4-1;cof1i++)
         {
         R1[cof1i]=COF1[COF1innm/4-1-cof1i];
         V1[cof1i]=COF1[COF1innm/4-1-cof1i+COF1innm/4];
         A1[cof1i]=COF1[COF1innm/4-1-cof1i+COF1innm/4*2];
         M1[cof1i]=COF1[COF1innm/4-1-cof1i+COF1innm/4*3];
         }
      }
   else
      Alert("File ",COF1fl," did not load");
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
  {
//----
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
{
//----Calc initial data
   double midin[],midsld[],velsld[],aclsld[];
   SetIndexStyle(0,DRAW_NONE,STYLE_DOT,3,Orange);
   SetIndexStyle(1,DRAW_LINE,STYLE_SOLID,3,Black);
   SetIndexStyle(6,DRAW_NONE,STYLE_SOLID,3,Lime);
   ArrayResize(midin,nobs);
   ArrayResize(midsld,nobs+ahdbars);
   for(int iz=0;iz<=ahdbars;iz++)
   {
      midsld[iz]=0;
      ahead[iz]=0;
      velsld[iz]=0;
   }
   //Print("midsld 7 ",midsld[7]," 6 ",midsld[6]," 5 ",midsld[5]," 4 ",midsld[4]," 3 ",midsld[3]," 2 ",midsld[2]," 1 ",midsld[1]," 0 ",midsld[0]);
   ahead[0]=1.3730;
   ahead[1]=1.3740;
   ahead[2]=1.3735;
   for(int ihp=0;ihp<nobs;ihp++)
   {
      midin[ihp]=(High[ihp]+Low[ihp])/2;
   }
   HPF(nobs,lambda,midin,hpfmid);
   for(int iv=nobs-1;iv>=0;iv--)
      {
      vel[iv]=hpfmid[iv]-hpfmid[iv+1];
      acl[iv]=vel[iv]-vel[iv+1];
      }
   HPF(nobs,lambda,acl,aclhp);
   ArrayCopy(midsld,hpfmid,ahdbars+1,0,nobs+1);
   ArrayCopy(velsld,vel,ahdbars+1,0,nobs+1);
   ArrayCopy(aclsld,acl,ahdbars+1,0,nobs+1);
   for(int ic=0;ic<=ArraySize(midsld);ic++)
      midslda[ic]=midsld[ic];
//----
   int calcbars=Bars-IndicatorCounted();
   //Print(calcbars);
   int strtcalc;
   int counted_bars;
   if(calcbars>ahdbars)
      strtcalc=nobs-4-ArraySize(R1);
   else
      strtcalc=calcbars+ahdbars;
//----
   for(int ihd=strtcalc;ihd>=0;ihd--)
   {
      if(ihd>strtcalc-ArraySize(R1)-2)
      {
         ahead[ihd]=fMMULT(ihd+1,midsld,R1)+fMMULT(ihd+1,velsld,V1)+fMMULT(ihd+1,aclsld,A1);
         err[ihd]=ahead[ihd]-midsld[ihd];
         //Print(ihd);
      }
      else
      {
         ahead[ihd]=fMMULT(ihd+1,midsld,R1)+fMMULT(ihd+1,velsld,V1)+fMMULT(ihd+1,aclsld,A1)+fMMULT(ihd+1,err,M1);
         err[ihd]=ahead[ihd]-midsld[ihd];
      }
   }
   midsld[2]=ahead[2];
   midslda[2]=midsld[2];
   velsld[2]=midsld[2]-midsld[3];
   aclsld[2]=velsld[2]-velsld[3];
   err[2]=midsld[3]-ahead[3];
   ahead[1]=fMMULT(2,midsld,R1)+fMMULT(2,velsld,V1)+fMMULT(2,aclsld,A1)+fMMULT(2,err,M1);
   midsld[1]=ahead[1];
   midslda[1]=midsld[1];
   velsld[1]=midsld[1]-midsld[2];
   err[1]=midsld[2]-ahead[2];
   aclsld[1]=velsld[1]-velsld[2];
   ahead[0]=fMMULT(1,midsld,R1)+fMMULT(1,velsld,V1)+fMMULT(1,aclsld,A1)+fMMULT(1,err,M1);
   //Print("midslda  ",midslda[32],"  ",midslda[31],"  ",midslda[30],"  ",midslda[29],"  ",midslda[28]);
   //Print("midsld  ",midsld[32],"  ",midsld[31],"  ",midsld[30],"  ",midsld[29],"  ",midsld[28]);
   //Print(ArraySize(velsld),"  ",ArraySize(hpfmid),"  ",nobs);
   //Print("err 8 ",err[8]," 7 ",err[7]," 6 ",err[6]," 5 ",err[5]," 4 ",err[4]," 3 ",err[3]," 2 ",err[2]," 1 ",err[1]);
   //Print("midsld 7 ",midsld[7]," 6 ",midsld[6]," 5 ",midsld[5]," 4 ",midsld[4]," 3 ",midsld[3]," 2 ",midsld[2]," 1 ",midsld[1]," 0 ",midsld[0]);
   //Print("midsld 7 ",midsld[7]," 6 ",midsld[6]," 5 ",midsld[5]," 4 ",midsld[4]," 3 ",midsld[3]," 2 ",midsld[2]," 1 ",midsld[1]," 0 ",midsld[0]);
   //Print("hpfmid 7 ",hpfmid[7]," 6 ",hpfmid[6]," 5 ",hpfmid[5]," 4 ",hpfmid[4]," 3 ",hpfmid[3]," 2 ",hpfmid[2]," 1 ",hpfmid[1]," 0 ",hpfmid[0]);
   //Print("ahead 5 ",ahead[5]," 4 ",ahead[4]," 3 ",ahead[3]," 2 ",ahead[2]," 1 ",ahead[1]," 0 ",ahead[0]);
   //Print("acl 7 ",acl[7]," 6 ",acl[6]," 5 ",acl[5]," 4 ",acl[4]," 3 ",acl[3]," 2 ",acl[2]," 1 ",acl[1]," 0 ",acl[0]);
   //Print("aclhp 7 ",aclhp[7]," 6 ",aclhp[6]," 5 ",aclhp[5]," 4 ",aclhp[4]," 3 ",aclhp[3]," 2 ",aclhp[2]," 1 ",aclhp[1]," 0 ",aclhp[0]);
   //Print("velsld 7 ",velsld[7]," 6 ",velsld[6]," 5 ",velsld[5]," 4 ",velsld[4]," 3 ",velsld[3]," 2 ",velsld[2]," 1 ",velsld[1]," 0 ",velsld[0]);
   //Print("err 300 ",err[300]," 299 ",err[299]," 298 ",err[298]," 297 ",err[297]," 296 ",err[296]," 295 ",err[295]," 294 ",err[294]," 293 ",err[293]);
   //Print("ahead 300 ",ahead[300]," 299 ",ahead[299]," 298 ",ahead[298]," 297 ",ahead[297]," 296 ",ahead[296]," 295 ",ahead[295]," 294 ",ahead[294]," 293 ",ahead[293]);
   //Print("midsld 303 ",midsld[303]," 302 ",midsld[302]," 301 ",midsld[301]," 300 ",midsld[300]," 299 ",midsld[299]," 298 ",midsld[298]," 297 ",midsld[297]," 296 ",midsld[296],"  ",ArraySize(midsld),"  ",ArraySize(hpfmid));
   //Print("velsld 303 ",velsld[303]," 302 ",velsld[302]," 301 ",velsld[301]," 300 ",velsld[300]," 299 ",velsld[299]," 298 ",velsld[298]," 297 ",velsld[297]," 296 ",velsld[296]);
   //Print("hpfmid 303 ",hpfmid[303]," 302 ",hpfmid[302]," 301 ",hpfmid[301]," 300 ",hpfmid[300]," 299 ",hpfmid[299]," 298 ",hpfmid[298]," 297 ",hpfmid[297]," 296 ",hpfmid[296],"  ",ArraySize(midsld),"  ",ArraySize(hpfmid));
//----
   return(0);
}
// Hodrick-Prescott Filter-----------------------------------------------------------------+
void HPF(int nobs, double lambda, double x[], double& y[])
{
   double a[],b[],c[],H1,H2,H3,H4,H5,HH1,HH2,HH3,HH4,HH5,HB,HC,Z;
   ArrayResize(a,nobs);
   ArrayResize(b,nobs);
   ArrayResize(c,nobs);
        
   a[0]=1.0+lambda;
   b[0]=-2.0*lambda;
   c[0]=lambda;
   for(int i=1;i<nobs-2;i++)
   {
      a[i]=6.0*lambda+1.0;
      b[i]=-4.0*lambda;
      c[i]=lambda;
   }
   a[1]=5.0*lambda+1;
   a[nobs-1]=1.0+lambda;
   a[nobs-2]=5.0*lambda+1.0;
   b[nobs-2]=-2.0*lambda;
   b[nobs-1]=0.0;
   c[nobs-2]=0.0;
   c[nobs-1]=0.0;
   
   //Forward
   for(i=0;i<nobs;i++)
   {
      Z=a[i]-H4*H1-HH5*HH2;
      HB=b[i];
      HH1=H1;
      H1=(HB-H4*H2)/Z;
      b[i]=H1;
      HC=c[i];
      HH2=H2;
      H2=HC/Z;
      c[i]=H2;
      a[i]=(x[i]-HH3*HH5-H3*H4)/Z;
      HH3=H3;
      H3=a[i];
      H4=HB-H5*HH1;
      HH5=H5;
      H5=HC;
   }
   
   //Backward 
   H2=0;
   H1=a[nobs-1];
   y[nobs-1]=H1;
   for(i=nobs-2;i>=0;i--)
   {
      y[i]=a[i]-b[i]*H1-c[i]*H2;
      H2=H1;
      H1=y[i];
   }
}
//+------------------------------------------------------------------+
double fMMULT(int startbar, double multiplier[], double multiplicand[])
{
   double sum=0;
   for(int i=0;i<ArraySize(multiplicand);i++)
   {
      sum=sum+multiplier[i+startbar]*multiplicand[i];
   }
   return(sum);
} 